from Graph import NeighborhoodGraph
from RCC8 import rcc8
import sys
import os
import random
import time

def createStart( num ):
    nhg = NeighborhoodGraph(  )

    regions = list( range( num ) ) 
    for r in regions:
        nhg.createNewRegion( r )
    return nhg, regions

num = int( sys.argv[1] )
out = open( "result_%03d.csv" % num, 'a' )
nhg, regions = createStart( num )
iterNum = 10000

out.write( "%d\n" % len( nhg.all_regions ) )
out.flush( )
os.fsync(out.fileno())

for idx in range( iterNum ):
    print( idx,"/",iterNum )
    try:
        for idx2 in range( 10 ):
            r1, r2 = random.sample( regions, 2 )
            trans = nhg.getPossibleTransitions( regions=[set([r1]),set([r2])] )
            if len( trans ) == 0:
                continue
            else:
                break
                
        trans = random.choice( trans )
        ts = time.time(  )
        trans[2]( nhg, trans[0], trans[1] )
        te = time.time(  )
        out.write( "%d\t%f\n" % ( len( nhg.all_regions ), te-ts ) )
        out.flush( )
        os.fsync(out.fileno())
    except Exception, e:
    	print e
        print( "Restarting ..." )
        nhg, regions = createStart( num )

out.close( )



